
function [template,templateZ] = ck_psych_RespTemplate(data,hit,fa,miss,cr,doboot)

% function [template,templateZ] = ck_psych_RespTemplate(data,hit,fa,miss,cr,doboot);
%
% Compute response Template from response categories
% doboot ~=0: compute Z-scored template from bootstrapped data

template =[];
templateZ=[];
if nargin < 5
  return;
end
if nargin < 6
  doboot =0;
end

template = nanmean(data(hit,:))  + nanmean(data(fa,:)) -( nanmean(data(miss,:)) + nanmean(data(cr,:)) );

%----------------------------------------------------------
% z-scoring
%----------------------------------------------------------
n1 =length(hit);
n2 =length(fa);
n3 =length(miss);
n4 =length(cr);

if doboot
  ntrial = size(data,1);
  tmp = zeros(doboot,size(data,2));
  for k=1:doboot
    hit2 = hit(ceil(rand(1,n1)*n1));
    fa2 = fa(ceil(rand(1,n2)*n2));
    miss2 = miss(ceil(rand(1,n3)*n3));
    cr2 = cr(ceil(rand(1,n4)*n4));
    tmp(k,:) = nanmean(data( hit2,:))  + nanmean(data(fa2,:)) -( nanmean(data(miss2,:)) + nanmean(data(cr2,:)) );
  end
  templateZ =template./std(tmp);
end
